#include "downloadremotedlg.h"
#include "ui_downloadremotedlg.h"

DownloadRemoteDlg::DownloadRemoteDlg(QWidget *parent, bool remoteStartupOnOff, QStringList *remotes) :
    QDialog(parent),
    m_ui(new Ui::DownloadRemoteDlg)
{
    remoteNames = remotes;
    remoteStartup = remoteStartupOnOff;
    m_ui->setupUi(this);
    this->setWindowTitle("Download remote");

    m_namManager = new QNetworkAccessManager(this);

    connect(m_namManager, SIGNAL(finished(QNetworkReply*)), this, SLOT(replyFinished(QNetworkReply*)));

    /*connect(client,SIGNAL(finish(int,QVariant)),this,SLOT(processReturnValue(int,QVariant)));
    connect(client,SIGNAL(networkError(int,QString)),this,SLOT(error(int,QString)));
    connect(client,SIGNAL(fault(int,int,QString)),this,SLOT(fault(int,int,QString )));
    QList<QVariant> list;
    list.clear();
    alphabeticalId = client->call("getLircDirs",list);*/

    connect(m_ui->alphabeticalList,SIGNAL(itemClicked(QListWidgetItem*)),this,SLOT(getManufacturers(QListWidgetItem*)));
    connect(m_ui->manufacturerList,SIGNAL(itemClicked(QListWidgetItem*)),this,SLOT(getModels(QListWidgetItem*)));
    connect(m_ui->remoteList,SIGNAL(itemClicked(QListWidgetItem*)),this,SLOT(getFile(QListWidgetItem*)));

    QNetworkRequest l_nrRequest;
    l_nrRequest.setUrl(QUrl("http://lirc.sourceforge.net/remotes/"));
    l_nrRequest.setRawHeader("User-Agent", "qtirreco");

    m_namManager->get(l_nrRequest);
    QMessageBox::warning(this, tr("myversion"), tr("this is my version"));
}

DownloadRemoteDlg::~DownloadRemoteDlg()
{
    delete m_ui;
}

void DownloadRemoteDlg::replyFinished(QNetworkReply *p_nrReply)
{
    QStringList l_slResult;
    QStringList l_slFilePreloads;
    QByteArray l_baAnswer = p_nrReply->readAll();
    int l_iIndex = 0;
    int l_iStringSize = 0;
    QString l_sUrl = p_nrReply->url().toString();
    QByteArray l_baElement;

    /*ui->plainTextEdit->clear();
    ui->plainTextEdit->insertPlainText(p_nrReply->url().toString());*/

    // Vendorlist
    if(l_sUrl.compare("http://lirc.sourceforge.net/remotes/") == 0)
    {
       l_iStringSize = QString("folder.gif\" alt=\"[DIR]\"></td><td><a href=\"").size();
        while(l_iIndex != -1)
        {
            l_iIndex = l_baAnswer.indexOf("folder.gif\" alt=\"[DIR]\"></td><td><a href=\"");
            if(l_iIndex == -1) // for the case "folder.gif\" alt=\"[DIR]\"></td><td><a href=\"" is not found
            {
                break;
            }
            l_baAnswer = l_baAnswer.right(l_baAnswer.size() - l_iIndex - l_iStringSize);

            l_baElement = l_baAnswer.left(l_baAnswer.indexOf("/"));
            l_slResult.append(l_baElement);
        }
        m_ui->manufacturerList->clear();
        m_ui->manufacturerList->insertItems(0, l_slResult);
        /*ui->vendorListWidget->clear();
        ui->vendorListWidget->insertItems(0, l_slResult);*/
    }
    else if(l_sUrl.at(l_sUrl.size()-1) == '/') // Remotelist
    {
        l_slFilePreloads << "text.gif\" alt=\"[   ]\"></td><td><a href=\""
                         << "text.gif\" alt=\"[TXT]\"></td><td><a href=\""
                         << "script.gif\" alt=\"[   ]\"></td><td><a href=\""
                         << "script.gif\" alt=\"[TXT]\"></td><td><a href=\"";
        unsigned int l_iTmp = -1;

        while(l_iIndex != -1)
        {
            l_iTmp = -1;
            for(int i = 0; i < l_slFilePreloads.size(); i++)
            {
                l_iIndex = l_baAnswer.indexOf(l_slFilePreloads.at(i));

                //QMessageBox::warning(this, tr("test"), tr("l_iIndex: %1").arg(l_iIndex));
                if(l_iIndex < l_iTmp && l_iIndex != -1)
                {
                    l_iTmp = l_iIndex;
                    l_iStringSize = l_slFilePreloads.at(i).size();
                }
            }
            l_iIndex = l_iTmp;

            //QMessageBox::warning(this, tr("test"), tr("l_iIndex: %1").arg(l_iIndex));
            if(l_iIndex == -1)
            {
                break;
            }
            l_baAnswer = l_baAnswer.right(l_baAnswer.size() - l_iIndex - l_iStringSize);

            l_baElement = l_baAnswer.left(l_baAnswer.indexOf("\""));
            l_slResult.append(l_baElement);
        }
        m_ui->remoteList->clear();
        m_ui->remoteList->insertItems(0, l_slResult);
        /*ui->remoteListWidget->clear();
        ui->remoteListWidget->insertItems(0, l_slResult);*/
    }
    else // Download
    {
        QMessageBox::warning(this, tr("test"), l_baAnswer);
        processReturnValue(fileId, l_baAnswer);
        //ui->plainTextEdit->insertPlainText(l_baAnswer);
    }
    p_nrReply->deleteLater();
}

void DownloadRemoteDlg::getManufacturers(QListWidgetItem* item)
{
    /*rangeItemString =item->text();
    QList<QVariant> range;
    range.append(rangeItemString);
    manufacturerId = client->call("getLircManufacturers",range);*/
}

void DownloadRemoteDlg::getModels(QListWidgetItem* item)
{
    QNetworkRequest l_nrRequest;
    l_nrRequest.setUrl(QUrl("http://lirc.sourceforge.net/remotes/" + item->text() + "/"));
    l_nrRequest.setRawHeader("User-Agent", "qtirreco");

    m_namManager->get(l_nrRequest);

    /*manufacturerItemString = rangeItemString+ "/" + item->text();
    QList<QVariant> manufacturer;
    manufacturer.append(manufacturerItemString);
    modelId = client->call("getLircModels",manufacturer);*/
}

void DownloadRemoteDlg::getFile(QListWidgetItem* item)
{
    QNetworkRequest l_nrRequest;
    l_nrRequest.setUrl(QUrl("http://lirc.sourceforge.net/remotes/" + m_ui->manufacturerList->currentItem()->text() + "/" + item->text()));
    l_nrRequest.setRawHeader("User-Agent", "qtirreco");

    m_namManager->get(l_nrRequest);
    modelItem = m_ui->remoteList->currentItem()->text();

    /*modelItemString = manufacturerItemString + "/" + m_ui->remoteList->currentItem()->text();
    modelItem = m_ui->remoteList->currentItem()->text();
    QList<QVariant> file;
    file.append(modelItemString);
    fileId = client->call("getLircFile",file);*/
}

void DownloadRemoteDlg::processReturnValue(int Id, QVariant data)
{
    QString l_sData = data.toString();
    QStringList sList;
    sList = l_sData.split('\n');
    //QMessageBox::warning(this, tr("test"), tr("sList.size(): %1").arg(sList.size()));

    /*if (Id == alphabeticalId) {
        m_ui->alphabeticalList->clear();
        m_ui->manufacturerList->clear();
        m_ui->remoteList->clear();
        m_ui->alphabeticalList->insertItems(0,sList);
    }
    else if (Id == manufacturerId) {
        m_ui->manufacturerList->clear();
        m_ui->remoteList->clear();
        m_ui->manufacturerList->insertItems(0,sList);
    }
    else if (Id == modelId) {
        m_ui->remoteList->clear();
        m_ui->remoteList->insertItems(0,sList);
    }
    else if (Id == fileId) {*/
        QDir dir;
        if(!dir.exists(devicesPath))
            dir.mkpath(devicesPath);
        if(!QFile::exists(devicesPath + modelItem)) {
            //QMessageBox::warning(this, tr("file"), tr("... seems not to exist.."));
            QFile deviceFile(devicesPath + modelItem);
            deviceFile.open(QIODevice::WriteOnly | QIODevice::Text);
            QTextStream out(&deviceFile);
            for(int i= 0; i< sList.count();i++) { // Streams only one remote data to file
                QString line = sList.at(i) + '\n';
                //QMessageBox::warning(this, tr("singles"), line);
                out << line; // Original version had only this line.
                if(line.contains(("end remote"),Qt::CaseInsensitive))
                    break;
            }
            deviceFile.close();

            // Change device name to file name.
            QFile file(devicesPath + modelItem);
            QFile tempFile(devicesPath + modelItem+"temp");
            if (!file.open(QIODevice::ReadOnly | QIODevice::Text)) {
                QMessageBox::warning(this,"Error opening device file","Remote might not work properly",Qt::NoButton,Qt::NoButton);
                return;
            }

            if (!tempFile.open(QIODevice::WriteOnly | QIODevice::Text)) {
                QMessageBox::warning(this,"Error opening temp device file","Streaming might go wrong",Qt::NoButton,Qt::NoButton);
                return;
            }
            bool nameLineNext = false;

            QTextStream in(&file);
            QTextStream out2(&tempFile);

            while(!in.atEnd()) {
                QString line = in.readLine();
                if(nameLineNext && line.contains(("name"),Qt::CaseInsensitive)) {
                    line = QString("  name " + modelItem);
                    nameLineNext = false;
                }

                if(line.contains(("begin remote"),Qt::CaseInsensitive))
                    nameLineNext = true;

                out2 << line+"\n";
            }
            file.close();
            file.remove();
            tempFile.rename(devicesPath + modelItem);
            tempFile.close();



            QFile LircConfFile("/etc/lircd.conf");
            QStringList deviceList;
            LircConfFile.open(QIODevice::ReadWrite | QIODevice::Text);
            QTextStream io(&LircConfFile);
            while (!io.atEnd()) {
                QString line = io.readLine();
                deviceList.append(line);
            }
            LircConfFile.resize(0);
            QString lastLine;

            for(int j = 0; j<sList.count();j++) {
                lastLine =  sList.at(j);

                if (lastLine.contains(("end"), Qt::CaseInsensitive))
                    if(!deviceList.contains((modelItem),Qt::CaseInsensitive)) {
                       deviceList.append("include \"" + devicesPath + modelItem + "\"");

                    for(int i= 0; i< deviceList.count();i++) {
                        io << deviceList.at(i)+"\n";
                    }
                    j=sList.count();
                }
            }

            LircConfFile.close();
            // Lircpaths.conf file
            QString para = modelItem;
            QFile lircPathsFile(lircpathsConf);
            lircPathsFile.open(QIODevice::ReadWrite | QIODevice::Append);
            QTextStream stream(&lircPathsFile);
            bool lircExists = false;
            while(!stream.atEnd())
            {
                QString line = stream.readLine();
                if(line.contains((para),Qt::CaseInsensitive))
                    lircExists = true;
            }
            if(!lircExists) {
                stream << para + " "+ modelItemString + "\n";
                system("sudo /etc/init.d/lirc reload");
            }

            lircPathsFile.close();


            if(remoteStartup) {
                remotestartupdlg = new RemoteStartupDlg(para, this, remoteNames);
                connect(remotestartupdlg,SIGNAL(addButtonToLayoutSignalFromRSD(QString,QString,QString,QString,QStringList,int)),this,SLOT(addButtonToLayout(QString, QString,QString,QString,QStringList,int)));
                connect(remotestartupdlg,SIGNAL(remoteCreated(QString)),this,SLOT(enableRemoteNameAdding(QString)));
                connect(remotestartupdlg,SIGNAL(lwClear()),this,SLOT(clearScreenForNewRemote()));
                remotestartupdlg->exec();
                delete remotestartupdlg;
            }

        }
        else {
              //QMessageBox::warning(this, tr("exists"), "file exists!?");
              if(remoteStartup) {
                        remotestartupdlg = new RemoteStartupDlg(modelItem, this, remoteNames);
                        connect(remotestartupdlg,SIGNAL(addButtonToLayoutSignalFromRSD(QString,QString,QString,QString,QStringList,int)),this,SLOT(addButtonToLayout(QString, QString,QString,QString,QStringList,int)));
                        connect(remotestartupdlg,SIGNAL(remoteCreated(QString)),this,SLOT(enableRemoteNameAdding(QString)));
                        connect(remotestartupdlg,SIGNAL(lwClear()),this,SLOT(clearScreenForNewRemote()));
                        remotestartupdlg->exec();
                        delete remotestartupdlg;
                   }

              }
        if(!remoteStartup) this->close();
        //}
}
void DownloadRemoteDlg::error(int i ,QString string)
{
    QMessageBox::warning(this,"Error: "+QString::number(i,10),string,
                                 QMessageBox::NoButton,QMessageBox::NoButton);
}
void DownloadRemoteDlg::fault(int i,int j,QString string)
{
    Q_UNUSED(j);
    QMessageBox::warning(this,"Fault: "+QString::number(i,10),string,
                                 QMessageBox::NoButton,QMessageBox::NoButton);
}
void DownloadRemoteDlg::addButtonToLayout(QString fileNameUnPressed, QString fileNamePressed, QString confFileName, QString buttonText, QStringList aCommand, int number)
{
    emit addButtonToLayoutSignalFromRSD(fileNameUnPressed, fileNamePressed, confFileName, buttonText, aCommand, number);
}
void DownloadRemoteDlg::enableRemoteNameAdding(QString remoteName)
{
    emit remoteNameToLayoutWidget(remoteName);
}
void DownloadRemoteDlg::clearScreenForNewRemote()
{
    emit lwClearScreen();
    this->close();
}
